<?php
/**
 * An instance for state resolver classes
 *
 * @author		Roland Haeder <webmaster@shipsimu.org>
 * @version		0.0.0
 * @copyright	Copyright (c) 2007, 2008 Roland Haeder, 2009 - 2013 Core Developer Team
 * @license		GNU GPL 3.0 or any newer version
 * @link		http://www.shipsimu.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
interface StateResolver extends Resolver {
	/**
	 * Returns an state instance for a given package raw data and socket resource
	 *
	 * @param	$helperInstance		An instance of a ConnectionHelper class
	 * @param	$packageData		Raw package data
	 * @param	$socketResource		A valid socket resource
	 * @return	$stateInstance		An instance of the resolved state
	 */
	static function resolveStateByPackage (ConnectionHelper $helperInstance, array $packageData, $socketResource);

	/**
	 * Checks whether the given state is valid
	 *
	 * @param	$stateName	The default state we shall execute
	 * @return	$isValid	Whether the given state is valid
	 * @throws	EmptyVariableException	Thrown if given state is not set
	 */
	function isStateValid ($stateName);
}

// [EOF]
?>
